Index: pjproject/trunk/pjlib/src/pj/lock.c
===================================================================
--- pjproject/trunk/pjlib/src/pj/lock.c	(revision 892)
+++ pjproject/trunk/pjlib/src/pj/lock.c	(revision 893)
@@ -60,4 +60,5 @@
 {
     pj_lock_t *p_lock;
+    pj_mutex_t *mutex;
     pj_status_t rc;
 
@@ -69,8 +70,9 @@
 
     pj_memcpy(p_lock, &mutex_lock_template, sizeof(pj_lock_t));
-    rc = pj_mutex_create(pool, name, type, (pj_mutex_t**)&p_lock->lock_object);
+    rc = pj_mutex_create(pool, name, type, &mutex);
     if (rc != PJ_SUCCESS)
 	return rc;
 
+    p_lock->lock_object = mutex;
     *lock = p_lock;
     return PJ_SUCCESS;
@@ -146,4 +148,5 @@
 {
     pj_lock_t *p_lock;
+    pj_sem_t *sem;
     pj_status_t rc;
 
@@ -155,9 +158,9 @@
 
     pj_memcpy(p_lock, &sem_lock_template, sizeof(pj_lock_t));
-    rc = pj_sem_create( pool, name, initial, max, 
-		        (pj_sem_t**)&p_lock->lock_object);
+    rc = pj_sem_create( pool, name, initial, max, &sem);
     if (rc != PJ_SUCCESS)
         return rc;
 
+    p_lock->lock_object = sem;
     *lock = p_lock;
 
Index: pjproject/trunk/pjmedia/src/pjmedia/BladeMP3EncDLL.h
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/BladeMP3EncDLL.h	(revision 892)
+++ pjproject/trunk/pjmedia/src/pjmedia/BladeMP3EncDLL.h	(revision 893)
@@ -27,5 +27,6 @@
 
 #ifdef __GNUC__
-#define ATTRIBUTE_PACKED	__attribute__((packed))
+//#define ATTRIBUTE_PACKED	__attribute__((packed))
+#define ATTRIBUTE_PACKED
 #else
 #define ATTRIBUTE_PACKED
@@ -242,5 +243,5 @@
 typedef unsigned long	(*BECLOSESTREAM)			(HBE_STREAM);
 typedef void	(*BEVERSION)				(PBE_VERSION);
-typedef unsigned long	(*BEWRITEVBRHEADER)			(LPCSTR);
+typedef unsigned long	(*BEWRITEVBRHEADER)			(const char*);
 typedef unsigned long	(*BEWRITEINFOTAG)			(HBE_STREAM, const char * );
 
Index: pjproject/trunk/pjmedia/src/pjmedia/echo_speex.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/echo_speex.c	(revision 892)
+++ pjproject/trunk/pjmedia/src/pjmedia/echo_speex.c	(revision 893)
@@ -574,3 +574,2 @@
 }
 
- 
Index: pjproject/trunk/pjsip-apps/src/pjsua/pjsua_app.c
===================================================================
--- pjproject/trunk/pjsip-apps/src/pjsua/pjsua_app.c	(revision 892)
+++ pjproject/trunk/pjsip-apps/src/pjsua/pjsua_app.c	(revision 893)
@@ -1115,5 +1115,5 @@
     if (config->udp_cfg.tls_setting.timeout.sec) {
 	pj_ansi_sprintf(line, "--tls-neg-timeout %d\n",
-			config->udp_cfg.tls_setting.timeout.sec);
+			(int)config->udp_cfg.tls_setting.timeout.sec);
 	pj_strcat2(&cfg, line);
     }
Index: pjproject/trunk/pjsip-apps/src/samples/siprtp.c
===================================================================
--- pjproject/trunk/pjsip-apps/src/samples/siprtp.c	(revision 892)
+++ pjproject/trunk/pjsip-apps/src/samples/siprtp.c	(revision 893)
@@ -1279,4 +1279,5 @@
 	     */
 	    pj_status_t status;
+	    const void *p_hdr;
 	    const pjmedia_rtp_hdr *hdr;
 	    pj_ssize_t size;
@@ -1288,8 +1289,10 @@
 					     strm->bytes_per_frame, 
 					     strm->samples_per_frame,
-					     (const void**)&hdr, &hdrlen);
+					     &p_hdr, &hdrlen);
 	    if (status == PJ_SUCCESS) {
 
 		//PJ_LOG(4,(THIS_FILE, "\t\tTx seq=%d", pj_ntohs(hdr->seq)));
+		
+		hdr = (const pjmedia_rtp_hdr*) p_hdr;
 
 		/* Copy RTP header to packet */
Index: pjproject/trunk/pjsip/src/pjsip/sip_dialog.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsip/sip_dialog.c	(revision 892)
+++ pjproject/trunk/pjsip/src/pjsip/sip_dialog.c	(revision 893)
@@ -455,5 +455,5 @@
 	/* Find next Record-Route header. */
 	rr = rr->next;
-	if (rr == (pjsip_rr_hdr*)&rdata->msg_info.msg->hdr)
+	if (rr == (void*)&rdata->msg_info.msg->hdr)
 	    break;
 	rr = pjsip_msg_find_hdr(rdata->msg_info.msg, PJSIP_H_RECORD_ROUTE, rr);
Index: pjproject/trunk/pjsip/src/test-pjsip/msg_test.c
===================================================================
--- pjproject/trunk/pjsip/src/test-pjsip/msg_test.c	(revision 892)
+++ pjproject/trunk/pjsip/src/test-pjsip/msg_test.c	(revision 893)
@@ -113,5 +113,5 @@
 static pj_status_t test_entry( pj_pool_t *pool, struct test_msg *entry )
 {
-    pjsip_msg *parsed_msg, *ref_msg;
+    pjsip_msg *parsed_msg, *ref_msg = NULL;
     static pjsip_msg *print_msg;
     pj_status_t status = PJ_SUCCESS;